/* Make sure that your use has access to DBMS_HPROF*/
CONNECT SYS/SYS11G@ora11g AS SYSDBA;
GRANT EXECUTE ON DBMS_HPROF TO SCOTT;


/*Create destination directory*/
CONNECT SCOTT/TIGER@ora11g
CREATE DIRECTORY IO AS 'E:\IO';

/*Start Profiling*/
BEGIN
    dbms_hprof.start_profiling(LOCATION=>'IO',FILENAME=>'HProf.txt');
END;
/

/*Simulate activity*/
DECLARE
    PROCEDURE p_doSomething (pi_empno NUMBER) IS
    BEGIN
        dbms_lock.sleep(0.1);
    END;
    PROCEDURE p_main IS
    BEGIN
        dbms_lock.sleep(0.5);
        FOR c IN (SELECT * FROM emp) LOOP
            p_doSomething(c.empno);
        END LOOP;
    END;
BEGIN
    p_main();
END;
/

/*Stop profiling*/
BEGIN
    dbms_hprof.stop_profiling;
END;
/

/*
 Find raw generated file (E:\IO\HProf.txt) and make it readable via the command-line utility:

c:\TEMP>PLSHPROF -output Hprof01 HProf.txt
PLSHPROF: Oracle Database 12c Enterprise Edition Release 12.1.0.1.0 - 64bit Production
[7 symbols processed]
[Report written to 'Hprof01.html']

*/