CREATE OR REPLACE FUNCTION f_search_tt
    (i_empno NUMBER:=NULL,
     i_ename_tx VARCHAR2:=NULL,
     i_loc_tx VARCHAR2:=NULL,
     i_limit_nr NUMBER:=50)
RETURN emp_search_nt IS
    v_out_tt emp_search_nt:=emp_search_nt(); -- output structure
    v_from_tx VARCHAR2(32767):='emp';
    v_where_tx VARCHAR2(32767):='rownum<=v_limit_nr';
    v_plsql_tx VARCHAR2(32767);
BEGIN
    IF i_empno IS NOT NULL THEN
        v_where_tx:=v_where_tx||chr(10)||'and emp.empno=v_empno_nr';
    END if;

    IF i_ename_tx IS NOT NULL THEN
        v_where_tx:=v_where_tx||chr(10)||'and emp.ename like ''%''||v_ename_tx||''%''';
    END IF;

    IF i_loc_tx IS NOT NULL THEN
        v_from_tx:=v_from_tx||chr(10)||'join dept on (emp.deptno=dept.deptno)';
        v_where_tx:=v_where_tx||chr(10)||'and dept.loc=v_loc_tx';
    END IF;

    v_plsql_tx:=
        'declare '||chr(10)||
        'v_limit_nr number:=:1;'||chr(10)||
        'v_empno_nr number:=:2;'||chr(10)||
        'v_ename_tx varchar2(256):=:3;'||chr(10)||
        'v_loc_tx varchar2(256):=:4;'||chr(10)||
        'begin '||chr(10)||
        'select emp_search_ot('||
        'emp.empno,emp.ename||''(''||emp.job||'')'','||
        'emp.sal+nvl(emp.comm,0))'||chr(10)||
        'bulk collect into :5'||chr(10)||
        'from '||v_from_tx||chr(10)||
        'where '||v_where_tx||';'||chr(10)||
        'end;';
        
    
    $IF $$MishaDebug $THEN
        dbms_output.put_line('<<Script that was executed>>'||chr(10)||v_plsql_tx);
    $END

    EXECUTE IMMEDIATE v_plsql_tx USING
        IN i_limit_nr, IN i_empno, IN i_ename_tx, IN i_loc_tx,
        OUT v_out_tt;
    RETURN v_out_tt;
END;
/