-- Test 1: Impact of predicate filters
SELECT empno, ename, f_change_nr(empno) change_nr
FROM emp
WHERE f_change_nr(empno) IS NOT NULL
AND deptno = 20
/
exec counter_pkg.p_check

-- Test 2: Impact of ORDER BY
SELECT empno, ename, f_change_nr(empno) change_nr
FROM emp
WHERE deptno = 20
ORDER BY 3;

exec counter_pkg.p_check;

SELECT empno, change_nr
FROM (
    SELECT empno, ename, f_change_nr(empno) change_nr
    FROM emp
    WHERE deptno = 20
    ORDER BY 3
    )
/    
exec counter_pkg.p_check

-- Test 3: Impact of hint
SELECT empno, change_nr
FROM (
    SELECT /*+ NO_MERGE */empno, ename, f_change_nr(empno) change_nr
    FROM emp
    WHERE deptno = 20
    ORDER BY 3
    )
/
exec counter_pkg.p_check

-- Test 4: Impact of view
CREATE OR REPLACE VIEW v_emp AS
SELECT empno, ename, f_change_nr(empno) change_nr
FROM emp
WHERE deptno = 20
ORDER BY 3
/
SELECT empno, change_nr
FROM v_emp
/
exec counter_pkg.p_check
