set serveroutput on

-- Test 1: Outer Join
SELECT empno, f_change_nr(empno) change_nr, dname
FROM emp,
     dept
WHERE emp.deptno(+) = dept.deptno
/
exec counter_pkg.p_check

-- Test 2: Outer Join 
SELECT empno, f_change_nr(dept.deptno) change_nr, dname
FROM emp,
     dept
WHERE emp.deptno(+) = dept.deptno
/
exec counter_pkg.p_check

-- Test 3: Outer Join - deterministic
CREATE OR REPLACE FUNCTION f_change_det_nr (i_nr NUMBER) RETURN NUMBER
    DETERMINISTIC
IS
BEGIN
    counter_pkg.v_nr:=counter_pkg.v_nr+1;
    RETURN i_nr+1;
END;
/
SELECT empno, f_change_det_nr(dept.deptno) change_nr, dname
FROM emp,
    dept
WHERE emp.deptno(+) = dept.deptno
/
exec counter_pkg.p_check

