-- Sample Function (REQUIRES DB-LINK!)
CREATE OR REPLACE FUNCTION f_getDeptInfo_tx (i_deptno NUMBER) RETURN VARCHAR2 IS
    v_out_tx VARCHAR2(256);
BEGIN
    $IF $$MishaDebug $THEN
        log_pkg.p_log ('F_GetDeptInfo_Param:'||i_deptno);
    $END
    
    SELECT deptno INTO v_out_tx
    FROM scott.dept@remoteDB  added DB_link
    where deptno = i_deptno;
    
    $IF $$MishaDebug $THEN
        log_pkg.p_log ('After query 1');
    $END
    
    SELECT v_out_tx||':'||count(*) 
    INTO v_out_tx 
    FROM scott.emp
    WHERE deptno = i_deptno;

    $IF $$MishaDebug $then
        log_pkg.p_log ('Function end');
    $END

    RETURN v_out_tx;
EXCEPTION
    WHEN OTHERS THEN
        log_pkg.p_log(dbms_utility.format_error_stack);
        log_pkg.p_log(dbms_utility.format_error_backtrace);
    RAISE;
END;    
/
