-- Get base info
SELECT f_getdeptinfo_tx (10) FROM DUAL
/
SELECT a.name, b.value
FROM v$statname a, v$mystat b
WHERE a.statistic# = b.statistic#
    and name in ('db block gets', -- physical reads
                'consistent gets', -- logical reads
                'CPU used by this session', -- CPU
                'bytes sent via SQL*Net to dblink', -- DB-link
                'bytes received via SQL*Net from dblink' -- DB-link
                )
/
-- Fire function second time and compare to the baseline
SELECT f_getdeptinfo_tx (10) FROM DUAL
/
SELECT a.name, b.value
FROM v$statname a, v$mystat b
WHERE a.statistic# = b.statistic#
    and name in ('db block gets', -- physical reads
                'consistent gets', -- logical reads
                'CPU used by this session', -- CPU
                'bytes sent via SQL*Net to dblink', -- DB-link
                'bytes received via SQL*Net from dblink' -- DB-link
                )
/

-- Translated CPU-time to CPU-units
                
DECLARE
    v_units_nr NUMBER;
    v_time_nr NUMBER:=0.02; -- in seconds
BEGIN
    v_units_nr := DBMS_ODCI.ESTIMATE_CPU_UNITS(v_time_nr) * 1000;
    DBMS_OUTPUT.PUT_LINE('Instructions:'||round(v_units_nr));
END;
/
                