CREATE OR REPLACE FUNCTION f_attention_ot (i_empno NUMBER) 
RETURN emp_search_nt IS
    v_emp_rec emp%ROWTYPE;
    v_sub_nt emp_search_nt;
    v_comm_nt emp_search_nt;
    v_out_nt emp_search_nt;
begin
    -- load information about the logged user
    SELECT * INTO v_emp_rec FROM emp WHERE empno=i_empno;

    -- get subordinates
    IF v_emp_rec.job = 'MANAGER' THEN -- directly reporting
        SELECT emp_search_ot(
                emp.empno,
                emp.ename||'('||emp.job||')',
                emp.sal+nvl(emp.comm,0)
               )
        BULK COLLECT INTO v_sub_nt
        FROM emp
        WHERE mgr=i_empno;
    ELSIF v_emp_rec.job = 'PRESIDENT' THEN 
    -- get everybody except himself
        SELECT emp_search_ot(
                emp.empno,
                emp.ename||'('||emp.job||')',
                emp.sal+nvl(emp.comm,0)
               )
        BULK COLLECT INTO v_sub_nt
        FROM emp
        WHERE empno!=i_empno;
    END IF;
    
    -- check all people with commissions from other departments
    IF v_emp_rec.job IN ('MANAGER','ANALYST') THEN
        SELECT emp_search_ot(
            emp.empno,
            emp.ename||'('||emp.job||')',
            emp.sal+nvl(emp.comm,0))
        BULK COLLECT INTO v_comm_nt
        FROM emp
        WHERE comm IS NOT NULL
        AND deptno != v_emp_rec.deptno;
    END IF;
    
    -- merge two collection together
    dbms_output.put_line('Merging: '||v_sub_nt.count||'+'||v_comm_nt.count);
    
    --v_out_nt:= v_sub_nt MULTISET UNION DISTINCT v_comm_nt;
    select v_sub_nt MULTISET UNION DISTINCT v_comm_nt into v_out_nt from dual;
    
    RETURN v_out_nt;
END;
/
select *
from table(f_attention_ot(7782));