-- APPEND version
CREATE OR REPLACE PROCEDURE p_testatab_forall_append IS
    TYPE table_tt IS TABLE OF test_tab%ROWTYPE;
    TYPE number_tt IS TABLE OF BINARY_INTEGER;
    v_tt table_tt;
    v_cur SYS_REFCURSOR;
    v_main_tt number_tt;
    v_other_tt number_tt;
BEGIN
    OPEN v_cur FOR SELECT * FROM test_tab;
    LOOP
        v_main_tt:=number_tt();
        v_other_tt:=number_tt();
        FETCH v_cur BULK COLLECT INTO v_tt LIMIT 5000;
        EXIT WHEN v_tt.count()=0;
        FOR i IN v_tt.first..v_tt.last LOOP
            IF v_tt(i).object_type='TABLE' THEN
                v_main_tt.extend;
                v_main_tt(v_main_tt.last):=i;
            ELSE
                v_other_tt.extend;
                v_other_tt(v_other_tt.last):=i;
            END IF;
        END LOOP;    

        FORALL i IN VALUES OF v_main_tt
            INSERT /*+ APPEND_VALUES*/ INTO test_tab_main VALUES v_tt(i);
        FORALL i IN VALUES OF v_other_tt
            INSERT /*+ APPEND_VALUES*/ INTO test_tab_other VALUES v_tt(i);
        COMMIT;
        
        EXIT WHEN v_tt.count<5000;
    END LOOP;
    CLOSE v_cur;
END;
/
-- Compare results
truncate table test_tab_main;
truncate table test_tab_other;
exec runstats_pkg.rs_start;
exec p_testatab_forall_append;
exec runstats_pkg.rs_middle;
exec p_testtab_forall;
exec runstats_pkg.rs_stop;