-- Multiple errors
CREATE OR REPLACE TRIGGER emp_row_biu
BEFORE INSERT OR UPDATE ON emp
FOR EACH ROW
DECLARE
    v_error_tx VARCHAR2(32767);
BEGIN
    IF :NEW.sal>5000 THEN
        v_error_tx:=v_error_tx||CHR(10)||'* salary cannot exceed 5000';
    END IF;
    
    IF :NEW.comm>2000 THEN
        v_error_tx:=v_error_tx||CHR(10)||'* commissions cannot exceed 2000';
    END IF;
    
    IF v_error_tx IS NOT NULL THEN
        raise_application_error(-20001,'Errors:'||v_error_tx);
    END IF;
end;
/
UPDATE emp
SET sal=10000,
    comm=3000
WHERE empno=7902
/