-- Required objects
CREATE SEQUENCE test_trigger_seq
/
CREATE TABLE test_trigger_tab1 (a NUMBER, b VARCHAR2(1))
/
CREATE OR REPLACE TRIGGER test_trigger_tab1_bi
BEFORE INSERT ON test_trigger_tab1
FOR EACH ROW DISABLE
BEGIN
    IF :NEW.a IS NULL THEN
        :NEW.a:=test_trigger_seq.NEXTVAL;
    END IF;
END;
/
-- Run comparison: trigger vs direct passing
set serveroutput on
exec runstats_pkg.rs_start;
ALTER TRIGGER test_trigger_tab1_bi ENABLE
/
BEGIN
    FOR i IN 1..10000 LOOP
        INSERT INTO test_trigger_tab1(b) VALUES ('X');
    END LOOP;
END;
/
exec runstats_pkg.rs_middle;
ALTER TRIGGER test_trigger_tab1_bi DISABLE;
BEGIN
    FOR i IN 1..10000 LOOP
        INSERT INTO test_trigger_tab1(a,b) VALUES (test_trigger_seq.NEXTVAL,'X');
    END LOOP;
END;
/
exec runstats_pkg.rs_stop;

-- Run comparison: default value vs direct insert
ALTER TABLE test_trigger_tab1 MODIFY a DEFAULT test_trigger_seq.NEXTVAL;
BEGIN
    FOR i IN 1..10000 LOOP
        NSERT INTO test_trigger_tab1(b) VALUES ('X');
    END LOOP;
END;
/
exec runstats_pkg.rs_middle;
ALTER TABLE test_trigger_tab1 MODIFY a DEFAULT NULL;
BEGIN
    FOR i IN 1..10000 LOOP
        INSERT INTO test_trigger_tab1(a,b) VALUES (test_trigger_seq.NEXTVAL,'X');
    END LOOP;
END;
/
exec runstats_pkg.rs_stop;
