-- Create required objects
CREATE TABLE test_trigger_tab2 
    (a VARCHAR2(1),
    create_dt DATE INVISIBLE DEFAULT sysdate,
    create_by VARCHAR2(30) INVISIBLE DEFAULT user)
/
CREATE TABLE test_trigger_tab3 
    (a VARCHAR2(1),
    create_dt DATE,
    create_by VARCHAR2(30))
/    
CREATE OR REPLACE TRIGGER test_trigger_tab3_bi
BEFORE INSERT ON test_trigger_tab3
FOR EACH ROW
BEGIN
    :NEW.create_dt:=sysdate;
    :NEW.create_by:=user;
END;
/

-- Check impact
exec runstats_pkg.rs_start;
BEGIN
    FOR i IN 1..10000 LOOP
        INSERT INTO test_trigger_tab2(a) VALUES ('X'); -- invisible
    END LOOP;
END;
/
exec runstats_pkg.rs_middle;
BEGIN
    FOR i IN 1..10000 LOOP
        INSERT INTO test_trigger_tab3(a) VALUES ('X'); -- trigger
    END LOOP;
END;
/
exec runstats_pkg.rs_stop;
