-- prepare required objects
CREATE OR REPLACE FUNCTION f_searchTestTab_tt (i_type_tx VARCHAR2) RETURN test_tab_nt
IS
    v_out_tt test_tab_nt;
begin
    SELECT test_tab_ot(owner, object_name, object_id, object_type)
    BULK COLLECT INTO v_out_tt
    FROM test_tab
    WHERE object_type = i_type_tx;
    dbms_output.put_line('Inside f_searchTestTab_tt:'||v_out_tt.count);
    RETURN v_out_tt;
END;
/
CREATE OR REPLACE VIEW v_search_table AS
SELECT * FROM TABLE(f_searchTestTab_tt('TABLE'))
/
CREATE OR REPLACE TRIGGER v_search_table_IIUD
INSTEAD OF INSERT OR UPDATE OR DELETE ON v_search_table
BEGIN
    IF INSERTING THEN dbms_output.put_line('Insert');
    ELSIF UPDATING THEN dbms_output.put_line('Update');
    ELSIF DELETING THEN dbms_output.put_line('Delete');
    END IF;
END;
/
-- Fire DMLs and observe triggers firing
set serveroutput on
INSERT INTO v_search_table (object_id, name_tx) VALUES (-1,'A')
/
UPDATE v_search_table SET name_tx = 'Test' WHERE object_id = 5
/
DELETE FROM v_search_table WHERE object_id = 5
/