set serveroutput on

CREATE TABLE trigger_tab
    (id number primary key, 
     demo_cl CLOB);

CREATE OR REPLACE TRIGGER trigger_tab_biud
BEFORE INSERT OR DELETE OR UPDATE ON trigger_tab FOR EACH ROW
BEGIN
    IF inserting THEN dbms_output.put_line('Row-before-INSERT');
    ELSIF updating THEN dbms_output.put_line('Row-before-UPDATE');
    ELSIF deleting THEN dbms_output.put_line('Row-before-DELETE');
    END IF;
END;
/
-- trigger will be fired
INSERT INTO trigger_tab(id,demo_cl) 
VALUES (1,empty_clob())
/
-- trigger will not be fired
DECLARE
    v_cl CLOB;
BEGIN
    SELECT demo_cl
    INTO v_cl
    FROM trigger_tab
    WHERE id = 1 FOR UPDATE;
    dbms_lob.writeAppend(v_cl,1,'A');
END;
/
SELECT id, demo_cl 
FROM trigger_tab
/
