-- prepare data
ALTER TABLE secure_tab ADD (
    demoBasic_cl CLOB, 
    demoCache_cl CLOB
    )
LOB(demoBasic_cl) STORE AS BASICFILE 
LOB(demoCache_cl) STORE AS SECUREFILE(CACHE)
/    
UPDATE secure_tab SET demoBasic_cl = demo_cl, demoCache_cl = demo_cl
/

-- Test1: BasicFile NOCACHE vs. SecureFile NOCACHE
DECLARE
    v_nr number;
BEGIN
    runstats_pkg.rs_start;
    FOR c in (SELECT demo_cl FROM secure_tab) LOOP
        v_nr:=instr(c.demo_cl,'a');
    END LOOP;
    runstats_pkg.rs_middle;
    FOR c IN (SELECT demoBasic_cl FROM secure_tab) LOOP
        v_nr:=instr(c.demoBasic_cl,'a');
    END LOOP;
    runstats_pkg.rs_stop;
END;
/
-- Test 2: SecureFile NOCACHE vs. SecureFile CACHE
ALTER SYSTEM FLUSH BUFFER_CACHE
/
DECLARE
    v_nr NUMBER;
    v_demo_cl CLOB;
    v_demoCache_cl CLOB;
BEGIN
    SELECT demo_cl, demoCache_cl 
    INTO v_demo_cl, v_demoCache_cl
    FROM secure_tab where id = 1;
    
    runstats_pkg.rs_start;
    FOR i IN 1..20 LOOP
        v_nr:=instr(v_demo_cl,'a'||to_char(i));
    END LOOP;
    
    runstats_pkg.rs_middle;
    FOR i IN 1..20 LOOP
        v_nr:=instr(v_demoCache_cl,'a'||to_char(i));
    END LOOP;
    runstats_pkg.rs_stop;
END;
/
