CREATE TABLE secure_logging_tab 
    (id number, demo_cl CLOB) LOB(demo_cl)
STORE AS SecureFile
/
DECLARE
    v_cl CLOB;
BEGIN
    DBMS_LOB.CREATETEMPORARY(v_cl,true,dbms_lob.call);
    FOR i IN 1..250 LOOP
        DBMS_LOB.WRITEAPPEND(v_cl,4000,DBMS_RANDOM.STRING('x',4000));
    END LOOP;

    runstats_pkg.rs_start;
    EXECUTE IMMEDIATE
        'alter table secure_logging_tab modify lob (demo_cl) (cache logging)';
    FOR i IN 1..10 LOOP
        INSERT INTO secure_logging_tab(id, demo_cl) VALUES (i, v_cl);
    END LOOP;
    
    runstats_pkg.rs_middle;
    EXECUTE IMMEDIATE 'alter table secure_logging_tab '||
        ' modify lob (demo_cl) (cache filesystem_like_logging)';
    
    FOR i IN 11..20 LOOP
        INSERT INTO secure_logging_tab(id, demo_cl) VALUES (i, v_cl);
    END LOOP;
    runstats_pkg.rs_stop;
END;
/
