-- Buffered write
CREATE OR REPLACE PROCEDURE P_CHECK_LOB IS
    v_cl CLOB;
    v_buffer_tx VARCHAR2(32767);
    PROCEDURE p_flush IS
    BEGIN
        dbms_lob.writeappend(v_cl,length(v_buffer_tx), v_buffer_tx);
        v_buffer_tx:=null;
    END;
    PROCEDURE p_add (i_tx VARCHAR2) IS
    BEGIN
        IF length(i_tx)+length(v_buffer_tx)>32767 THEN
            p_flush;
            v_buffer_tx:=i_tx;
        ELSE
            v_buffer_tx:=v_buffer_tx||i_tx;
        END IF;
    END;
BEGIN
    dbms_lob.createTemporary(v_cl,true,dbms_lob.call); -- good code
    FOR c IN (SELECT object_name FROM all_objects WHERE ROWNUM<=50000)
    LOOP
        p_add(c.object_name);
    END LOOP;
    p_flush;
END;
/
-- Validate the impact
exec runstats_pkg.rs_start;
DECLARE
    v_cl CLOB;
BEGIN
    dbms_lob.createTemporary(v_cl,true,dbms_lob.call); -- good code
    FOR c IN (SELECT object_name FROM all_objects WHERE ROWNUM<=50000) LOOP
        dbms_lob.writeappend(v_cl,length(c.object_name), c.object_name);
    END LOOP;
END;
/
exec runstats_pkg.rs_middle;
exec P_CHECK_LOB;
exec runstats_pkg.rs_stop;