-- recreate SECURE_TAB
drop table secure_tab purge
/
CREATE TABLE secure_tab 
    (id number, 
     demo_cl CLOB)
LOB(demo_cl) STORE AS SecureFile
/
DECLARE
    v_cl CLOB;
BEGIN
    DBMS_LOB.CREATETEMPORARY(v_cl,true,dbms_lob.call);
    FOR i IN 1..250 LOOP
        DBMS_LOB.WRITEAPPEND(v_cl,4000,DBMS_RANDOM.STRING('x',4000));
    END LOOP;
END;
/
-- compare FRAGMENT operation to manual
exec runstats_pkg.rs_start;
DECLARE
    v_cl CLOB;
BEGIN
    FOR i IN 1..10 LOOP
        SELECT demo_cl INTO v_cl 
        FROM secure_tab 
        WHERE id = i FOR UPDATE;
        dbms_lob.fragment_insert
            (LOB_LOC=>v_cl,AMOUNT=>1,OFFSET=>500000,BUFFER=>'A');
    END LOOP;
END;
/
exec runstats_pkg.rs_middle;
declare
    v_cl CLOB;
    v_new_cl CLOB;
begin
    FOR i IN 11..20 LOOP
        SELECT demo_cl INTO v_cl FROM secure_tab WHERE id = i;
        dbms_lob.createTemporary(v_new_cl,true,dbms_lob.call);
        dbms_lob.append(v_new_cl, substr(v_cl,1,500000));
        dbms_lob.writeappend(v_new_cl,1,'A');
        dbms_lob.append(v_new_cl, substr(v_cl,500001));
        UPDATE secure_tab SET demo_cl = v_new_cl WHERE id=i;
    END LOOP;
END;
/
exec runstats_pkg.rs_stop;
