-- Create larger set
ALTER TABLE test_tab ADD
    (obj3_tx VARCHAR2(3),
    obj1_tx VARCHAR2(1))
/
UPDATE test_tab SET
obj3_tx = UPPER(SUBSTR(object_name,-3)), -- 3442 distinct values
obj1_tx = UPPER(SUBSTR(object_name,1,1)) -- 26 distinct values
/
CREATE TYPE stringList_tt IS TABLE OF VARCHAR2(256)
/
-- Default
DECLARE
    v_obj_tt stringList_tt;
    v_count_nr NUMBER;
    CURSOR c_rec IS
        SELECT f_change_det_tx(obj1_tx) obj_tx
        FROM test_tab;
BEGIN
    OPEN c_rec;
    FOR i IN 1..5 LOOP
        FETCH c_rec 
        BULK COLLECT INTO v_obj_tt LIMIT 100;
        SELECT COUNT(DISTINCT column_value)
        INTO v_count_nr
        FROM TABLE(CAST (v_obj_tt AS stringList_tt));        
        counter_pkg.p_check;
        dbms_output.put_line('-real count:'||v_count_nr);
    END LOOP;
    CLOSE c_REC;
END;
/
-- Large buffer size
ALTER SESSION SET "_query_execution_cache_max_size"=262144;
DECLARE
    v_obj_tt stringList_tt;
    v_count_nr NUMBER;
    CURSOR c_rec IS
        SELECT f_change_det_tx(obj1_tx) obj_tx
        FROM test_tab;
BEGIN
    OPEN c_rec;
    FOR i IN 1..5 LOOP
        FETCH c_rec 
        BULK COLLECT INTO v_obj_tt LIMIT 100;
        SELECT COUNT(DISTINCT column_value)
        INTO v_count_nr
        FROM TABLE(CAST (v_obj_tt AS stringList_tt));        
        counter_pkg.p_check;
        dbms_output.put_line('-real count:'||v_count_nr);
    END LOOP;
    CLOSE c_REC;
END;
/
