-- Bad ordering
DECLARE
    v_obj_tt stringList_tt;
    v_count_nr NUMBER;
    CURSOR c_rec IS
        SELECT f_change_det_tx(obj1_tx) obj_tx
        FROM test_tab
        ORDER BY obj1_tx;
BEGIN
    OPEN c_rec;
    FOR i in 1..2 LOOP
        FETCH c_rec 
        BULK COLLECT INTO v_obj_tt LIMIT 100;
        
        SELECT count(distinct column_value)
        INTO v_count_nr 
        FROM TABLE(CAST (v_obj_tt AS stringList_tt));
        
        counter_pkg.p_check;
        dbms_output.put_line('-real count:'||v_count_nr);
    END LOOP;
    CLOSE c_rec;
END;
/
-- Good ordering
DECLARE
    v_obj_tt stringList_tt;
    v_count_nr NUMBER;
    CURSOR c_rec IS
        SELECT f_change_det_tx(obj1_tx) obj_tx
        FROM (SELECT /*+ NO_MERGE*/ * 
        FROM test_tab 
        ORDER BY obj1_tx);
BEGIN
    OPEN c_rec;
    FOR i IN 1..2 LOOP
        FETCH c_rec 
        BULK COLLECT INTO v_obj_tt LIMIT 100;
        
        SELECT COUNT(DISTINCT column_value)
        INTO v_count_nr 
        FROM TABLE(CAST (v_obj_tt AS stringList_tt));
        
        counter_pkg.p_check;
        dbms_output.put_line('-real count:'||v_count_nr);
    END LOOP;
    CLOSE c_rec;
END;
/