-- Small data volume
SELECT empno, f_change_tx(job) FROM emp;
exec counter_pkg.p_check;
SELECT empno, (SELECT f_change_tx(job) FROM dual) FROM emp;
exec counter_pkg.p_check;

-- Large data volume
DECLARE
    v_obj_tt stringList_tt;
    v_count_nr NUMBER;
    CURSOR c_rec IS
        SELECT (SELECT f_change_tx(obj1_tx) FROM DUAL) obj_tx
        FROM test_tab;
BEGIN
    OPEN c_rec;
    FOR i IN 1..5 LOOP
        FETCH c_rec 
        BULK COLLECT INTO v_obj_tt LIMIT 100;
        SELECT COUNT(DISTINCT column_value)
        INTO v_count_nr 
        FROM TABLE(CAST (v_obj_tt as stringList_tt));
        counter_pkg.p_check;
        dbms_output.put_line('-real count:'||v_count_nr);
    END LOOP;
    CLOSE c_rec;
END;
/

-- Ordering impact
DECLARE
    v_obj_tt stringList_tt;
    v_count_nr NUMBER;
    CURSOR c_rec IS
    SELECT (SELECT f_change_tx(obj3_tx) FROM dual) obj_tx
    FROM (SELECT /*+ NO_MERGE */ * 
          FROM test_tab 
          ORDER BY obj3_tx);
BEGIN
    OPEN c_rec;
    FOR i IN 1..5 LOOP
        FETCH c_rec BULK COLLECT INTO v_obj_tt LIMIT 1000;
        SELECT COUNT(DISTINCT column_value)
        INTO v_count_nr 
        FROM TABLE(CAST (v_obj_tt AS stringList_tt));
        counter_pkg.p_check;
        dbms_output.put_line('-real count:'||v_count_nr);
    END LOOP;
    CLOSE c_rec;
END;
/
