CREATE OR REPLACE FUNCTION f_getDept_dsp (i_deptno NUMBER) RETURN VARCHAR2
RESULT_CACHE
IS
    v_out_tx VARCHAR2(256);
BEGIN
    IF i_deptno IS NULL THEN 
        RETURN NULL; 
    END IF;
    SELECT initcap(dname) INTO v_out_tx
    FROM dept WHERE deptno=i_deptno;
    counter_pkg.v_nr:=counter_pkg.v_nr+1;
    RETURN v_out_tx;
END;
/
--- Basic example
SELECT empno, f_getDept_dsp(deptno) dept_dsp FROM emp;
exec counter_pkg.p_check;
SELECT empno, f_getDept_dsp(deptno) dept_dsp FROM emp;
exec counter_pkg.p_check;

-- Result cache statistics
exec dbms_result_cache.memory_report
/
SELECT * FROM v$result_cache_statistics
/
SELECT id, type, status, name FROM V$RESULT_CACHE_OBJECTS
/
SELECT rco.id, rco.name, ao.owner||'.'||ao.object_name object_name
FROM v$result_cache_objects rco,
     v$result_cache_dependency rcd,
     all_objects ao
WHERE rco.id = rcd.result_id
AND rcd.object_no = ao.object_id
order by 1
/