CREATE OR REPLACE FUNCTION f_change_cache_tx (i_tx varchar2) 
RETURN VARCHAR2
    RESULT_CACHE IS
BEGIN
    counter_pkg.v_nr:=counter_pkg.v_nr+1;
    RETURN LOWER(i_tx);
END;
/
-- Result Cache vs Deterministic
exec runstats_pkg.rs_start;
SELECT MAX(f_change_cache_tx(obj1_tx)) FROM test_tab;
exec counter_pkg.p_check;
exec runstats_pkg.rs_middle;
SELECT MAX(f_change_det_tx(obj1_tx)) FROM test_tab;
exec counter_pkg.p_check;
exec runstats_pkg.rs_stop;

-- Result Cache vs Scalar Subquery
exec runstats_pkg.rs_start;
SELECT MAX(f_change_cache_tx(obj1_tx)) FROM test_tab;
exec counter_pkg.p_check;
exec runstats_pkg.rs_middle;
SELECT MAX((SELECT f_change_tx(obj1_tx) FROM DUAL)) FROM test_tab;
exec counter_pkg.p_check;
exec runstats_pkg.rs_stop;

-- Scalar Subuery+Result Cache vs Scalar Subquery
exec runstats_pkg.rs_start;
SELECT MAX((SELECT f_change_cache_tx(obj1_tx) FROM DUAL)) from test_tab;
exec counter_pkg.p_check;
exec runstats_pkg.rs_middle;
SELECT MAX((SELECT f_change_tx(obj1_tx) FROM DUAL)) FROM test_tab;
exec counter_pkg.p_check;
exec runstats_pkg.rs_stop;