-- Basic example
CREATE OR REPLACE PACKAGE emp_report_pkg IS
    TYPE displayList_tt IS TABLE OF VARCHAR2(4000) INDEX BY BINARY_INTEGER;
    gv_emp_tt displayList_tt;
    PROCEDURE p_reload;
    FUNCTION f_getEmpDSP_tx (i_empno NUMBER) RETURN VARCHAR2;
END;
/
CREATE OR REPLACE PACKAGE BODY emp_report_pkg IS
    FUNCTION f_getEmpDSP_tx (i_empno number) RETURN VARCHAR2 IS
    BEGIN
        IF i_empno IS NULL THEN RETURN NULL; END IF;
        IF gv_emp_tt.count=0 THEN p_reload; END IF;
        RETURN gv_emp_tt(i_empno);
    END;
    
    PROCEDURE p_reload IS
    BEGIN
        gv_emp_tt.delete;
        FOR emp_cur IN (SELECT empno, empno||' '||ename emp_dsp FROM emp)
        LOOP
            gv_emp_tt(emp_cur.empno):=emp_cur.emp_dsp;
        END LOOP;
    END;
END;
/

-- Reload on initiation
CREATE OR REPLACE PACKAGE emp_report_pkg IS
    TYPE displayList_tt IS TABLE OF VARCHAR2(4000) INDEX BY BINARY_INTEGER;
    gv_emp_tt displayList_tt;
    FUNCTION f_getEmpDSP_tx (i_empno NUMBER) RETURN VARCHAR2;
END;
/
CREATE OR REPLACE PACKAGE BODY emp_report_pkg IS
    FUNCTION f_getEmpDSP_tx (i_empno NUMBER) RETURN VARCHAR2 IS
    BEGIN
        IF i_empno IS NULL THEN RETURN NULL; END IF;
        RETURN gv_emp_tt(i_empno);
    END;    
BEGIN
    FOR emp_cur IN (SELECT empno, empno||' '||ename emp_dsp FROM emp)
    LOOP
        gv_emp_tt(emp_cur.empno):=emp_cur.emp_dsp;
    END LOOP;
END;
/