-- Context and counter
CREATE CONTEXT scott_context USING counter_pkg;

CREATE OR REPLACE PACKAGE counter_pkg IS
    v_nr number:=0;
    PROCEDURE p_check;
    PROCEDURE p_incrementVariable;
    PROCEDURE p_incrementContext;
    PROCEDURE p_checkContext;
END;
/
CREATE OR REPLACE PACKAGE BODY counter_pkg IS
    PROCEDURE p_check IS
    BEGIN
        dbms_output.put_line('Fired:'||counter_pkg.v_nr);
        counter_pkg.v_nr:=0;
    END;
    
    PROCEDURE p_incrementVariable IS
    BEGIN
        counter_pkg.v_nr:=counter_pkg.v_nr+1;
    END;
    
    PROCEDURE p_checkContext IS
    BEGIN
        dbms_output.put_line('Context:'||sys_context('scott_context','counter'));
        dbms_session.set_context('scott_context', 'counter', 0);
    END;
    
    PROCEDURE p_incrementContext IS
    BEGIN
        dbms_session.set_context('scott_context', 'counter',
        sys_context('scott_context','counter')+1);
    END;
END;
/
-- Performance comparison
exec runstats_pkg.rs_start;
BEGIN
    FOR i IN 1..10000 LOOP
        counter_pkg.p_incrementContext;
    END LOOP;
END;
/
exec runstats_pkg.rs_middle;
BEGIN
    FOR I IN 1..10000 LOOP
        counter_pkg.p_incrementVariable;
    END LOOP;
END;
/
exec runstats_pkg.rs_stop;