CREATE OR REPLACE FUNCTION f_getCount_nr (i_tab_tx varchar2) 
RETURN NUMBER
RESULT_cache
IS
    v_sql_tx VARCHAR2(256);
    v_out_nr NUMBER;
BEGIN
    EXECUTE IMMEDIATE 'SELECT COUNT(*) FROM '||i_tab_tx INTO v_out_nr;
    RETURN v_out_nr;
END;
/
-- Proof of caching
SELECT f_getCount_nr('EMP') FROM DUAL;

SELECT ro.id, ro.name, ao.object_name
FROM v$result_cache_objects ro,
    v$result_cache_dependency rd,
    dba_objects ao
WHERE ro.id = rd.result_id
AND rd.object_no = ao.object_id;

SELECT f_getCount_nr('EMP') FROM DUAL;

SELECT * FROM v$result_cache_statistics
WHERE NAME IN ('Create Count Success','Find Count');

-- Proof of data invalidation
INSERT INTO emp(empno) VALUES (100);
COMMIT;

SELECT f_getCount_nr('EMP') FROM DUAL;

SELECT id, name, value
FROM v$result_cache_statistics
WHERE NAME IN ('Create Count Success','Find Count','Invalidation Count');

DELETE FROM emp WHERE empno=100;

-- Proof of new detected dependencies
SELECT f_getCount_nr('DEPT') FROM dual;

SELECT rco.id, rco.name, ao.owner||'.'||ao.object_name object_name
FROM v$result_cache_objects rco,
    v$result_cache_dependency rcd,
    all_objects ao
WHERE rco.id = rcd.result_id
AND rcd.object_no = ao.object_id;

SELECT id, name, value
FROM v$result_cache_statistics
WHERE NAME IN ('Create Count Success','Find Count','Invalidation Count');