CREATE OR REPLACE FUNCTION f_search_ref
    (i_empno NUMBER:=NULL, 
     i_ename_tx VARCHAR2:=NULL, 
     i_loc_tx VARCHAR2:=NULL)
RETURN SYS_REFCURSOR IS
    v_ref sys_REFCURSOR;
    v_from_tx VARCHAR2(32767):='emp';
    v_where_tx VARCHAR2(32767):='1=1';
    v_plsql_tx VARCHAR2(32767);
BEGIN
    IF i_empno IS NOT NULL THEN
        v_where_tx:=v_where_tx||chr(10)||'and emp.empno=v_empno_nr';
    END if;
    
    IF i_ename_tx IS NOT NULL THEN
        v_where_tx:=v_where_tx||chr(10)||'and emp.ename like ''%''||v_ename_tx||''%''';
    END IF;
    
    IF i_loc_tx IS NOT NULL THEN
        v_from_tx:=v_from_tx||chr(10)||'join dept on (emp.deptno=dept.deptno)';
        v_where_tx:=v_where_tx||chr(10)||'and dept.loc=v_loc_tx';
    END IF;
    
    v_plsql_tx:=
        'DECLARE '||chr(10)||
        'v_empno_nr NUMBER:=:1;'||chr(10)||
        'v_ename_tx VARCHAR2(256):=:2;'||chr(10)||
        'v_loc_tx VARCHAR2(256):=:3;'||chr(10)||
        'BEGIN '||chr(10)||
        ' OPEN :4 FOR SELECT emp.empno, emp.ename||''(''||emp.job||'')'' empno_dsp,'||
        'emp.sal+nvl(emp.comm,0) comp_nr'||chr(10)||
        'FROM '||v_from_tx||chr(10)||
        'WHERE '||v_where_tx||';'||chr(10)||
        'END;';
        
    EXECUTE IMMEDIATE v_plsql_tx USING
        IN i_empno, IN i_ename_tx, IN i_loc_tx,
        IN v_ref;
        
    RETURN v_ref;
END;
/
-- example
DECLARE
    v_ref SYS_REFCURSOR;
    v_empno_nr NUMBER;
    v_empno_dsp VARCHAR2(256);
    v_comp_nr NUMBER;
BEGIN
    v_ref:=f_search_ref(NULL,'SMITH',NULL);
    FETCH v_ref INTO v_empno_nr, v_empno_dsp, v_comp_nr;
    dbms_output.put_line(v_empno_nr||' '||v_empno_dsp||': '||v_comp_nr);
    CLOSE v_ref;
END;
/
