CREATE OR REPLACE FUNCTION f_search_pipe_tt
    (i_empno NUMBER:=NULL, 
     i_ename_tx VARCHAR2:=NULL, 
     i_loc_tx VARCHAR2:=null,
    i_page_nr NUMBER:=50)
RETURN emp_search_nt
PIPELINED
IS
    v_ref sys_refcursor;
    v_out_tt emp_search_nt;
    v_from_tx VARCHAR2(32767):='emp';
    v_where_tx VARCHAR2(32767):='1=1';
    v_plsql_tx VARCHAR2(32767);
BEGIN
    IF i_empno IS NOT NULL THEN
        v_where_tx:=v_where_tx||chr(10)||'and emp.empno=v_empno_nr';
    END if;
    IF i_ename_tx IS NOT NULL THEN
        v_where_tx:=v_where_tx||chr(10)||'and emp.ename like ''%''||v_ename_tx||''%''';
    END IF;
    
    IF i_loc_tx IS NOT NULL THEN
        v_from_tx:=v_from_tx||chr(10)||'JOIN DEPT ON (emp.deptno=dept.deptno)';
        v_where_tx:=v_where_tx||chr(10)||'AND dept.loc=v_loc_tx';
    END IF;
    
    v_plsql_tx:=
        'DECLARE '||chr(10)||
        'v_empno_nr NUMBER:=:1;'||chr(10)||
        'v_ename_tx VARCHAR2(256):=:2;'||chr(10)||
        'v_loc_tx VARCHAR2(256):=:3;'||chr(10)||
        'begin '||chr(10)||
        ' OPEN :4 for select emp_search_ot(emp.empno,emp.ename||
        ''(''||emp.job||'')'','||
        'emp.sal+nvl(emp.comm,0))'||chr(10)||
        'FROM '||v_from_tx||chr(10)||
        'WHERE '||v_where_tx||';'||chr(10)||
        'END;';

    EXECUTE IMMEDIATE v_plsql_tx USING
        IN i_empno, IN i_ename_tx, IN i_loc_tx,
        IN v_ref;
        
    LOOP
        FETCH v_ref BULK COLLECT INTO v_out_tt LIMIT i_page_nr;
        EXIT WHEN v_out_tt.count = 0;
        FOR i IN 1..v_out_tt.COUNT LOOP
            PIPE ROW (v_out_tt(i));
        END LOOP;
        EXIT WHEN v_out_tt.count<i_page_nr;
    END LOOP;
    
    CLOSE v_ref;
    RETURN;
END;
/