CREATE OR REPLACE PROCEDURE p_truncate IS
    v_exist_yn VARCHAR2(1);
BEGIN
    SELECT 'Y'
    INTO v_exist_yn
    FROM v$session s,
         v$tempseg_usage u
    WHERE s.audsid = SYS_CONTEXT('USERENV','SESSIONID')
    AND s.saddr = u.session_addr
    AND u.segtype = 'DATA'
    AND rownum = 1;

    FOR c IN (SELECT table_name FROM user_tables
            WHERE TEMPORARY = 'Y' and DURATION = 'SYS$SESSION') 
    LOOP
        EXECUTE IMMEDIATE 'truncate table '||c.table_name;
    END LOOP;
END;
/