-- Load memory
CREATE OR REPLACE PACKAGE testMemory_pkg IS
    TYPE list_tt IS TABLE OF VARCHAR2(32767);
    v_tt list_tt:=list_tt();
END;
/
BEGIN
    testMemory_pkg.v_tt.extend(1000);
    FOR i IN 1..1000 LOOP
        testMemory_pkg.v_tt(i):=LPAD('X',32767,'X');
    END LOOP;
END;
/

-- Check the load
SELECT a.name name, b.value
FROM v$statname a, 
     v$mystat b
WHERE a.statistic# = b.statistic#
AND a.name like '%pga%'
/

-- Release memory
begin
    dbms_session.reset_package;
    dbms_session.free_unused_user_memory;
end;
/

-- Confirm releasing
SELECT a.name name, b.value
FROM v$statname a, v$mystat b
WHERE a.statistic# = b.statistic#
AND a.name LIKE '%pga%'
/
