-- Test #1 - All cursors are kept open
CREATE OR REPLACE FUNCTION f_processLevelDown_tx (i_fk NUMBER) RETURN VARCHAR2 IS
    v_out_tx VARCHAR2(32767);
BEGIN
    FOR c IN (SELECT * FROM emp WHERE mgr = i_fk) LOOP
        dbms_output.put_line
            ('Cursors:'||f_getStat_Nr('opened cursors current')||'>'||c.ename);
        v_out_tx:= f_processLevelDown_tx (c.empno);
        IF v_out_tx!='OK' then
            raise_application_error(-20999,v_out_tx);
        END IF;
    END LOOP;
    RETURN 'OK';
EXCEPTION
    WHEN OTHERS THEN RETURN 'E:FK'||i_fk||'> error:'||SQLERRM;
END;
/
DECLARE
    v_tx VARCHAR2(32767);
BEGIN
    dbms_output.put_line('* Before:'||f_getStat_Nr('opened cursors current'));
    FOR c IN (SELECT * FROM emp WHERE mgr IS NULL) LOOP
        dbms_output.put_line(
            'Cursors:'||f_getStat_Nr('opened cursors current')||'>'||c.ename);
        v_tx:=f_processLevelDown_tx(c.empno);
    END LOOP;
     dbms_output.put_line('* After:'||f_getStat_Nr('opened cursors current'));
END;
/

-- Test #2 - cursor is immediately fetched to the collection
CREATE OR REPLACE FUNCTION f_processLevelDown_tx (i_fk number) RETURN VARCHAR2 IS
    v_out_tx VARCHAR2(32000);
    TYPE rec_tt IS TABLE OF emp%rowtype;
    v_tt rec_tt;
BEGIN
    SELECT *
    BULK COLLECT INTO v_tt
    FROM emp
    WHERE mgr = i_fk;
    
    IF v_tt.count()>0 THEN
        FOR i IN v_tt.first..v_tt.last LOOP
            dbms_output.put_line
                ('Cursors:'||f_getStat_Nr('opened cursors current')||'>'||v_tt(i).ename);
            v_out_tx:=f_processLevelDown_tx(v_tt(i).empno);
            IF v_out_tx!='OK' THEN
                raise_application_error(-20999,v_out_tx);
            END IF;
        END LOOP;
    END IF;
    
    RETURN 'OK';
EXCEPTION
    WHEN OTHERS THEN RETURN 'E:FK'||i_fk||'> error:'||sqlerrm;
END;
/
DECLARE
    v_tx VARCHAR2(32767);
BEGIN
    dbms_output.put_line('* Before:'||f_getStat_Nr('opened cursors current'));
    FOR c IN (SELECT * FROM emp WHERE mgr IS NULL) LOOP
        dbms_output.put_line(
            'Cursors:'||f_getStat_Nr('opened cursors current')||'>'||c.ename);
        v_tx:=f_processLevelDown_tx(c.empno);
    END LOOP;
     dbms_output.put_line('* After:'||f_getStat_Nr('opened cursors current'));
END;
/