-- Create edition-enabled user and connect as that user
-- !!! you need to be connected as user with DBA privileges!!!
CREATE USER scott_ebr IDENTIFIED BY scott_ebr
DEFAULT TABLESPACE USERS TEMPORARY TABLESPACE TEMP
ENABLE EDITIONS
/
GRANT dba TO scott_ebr
/
CONNECT scott_ebr/scott_ebr@pdbora12c
/
-- create testing objects
CREATE TABLE test_tab AS SELECT * FROM scott.test_tab WHERE ROWNUM < 100
/
CREATE FUNCTION f_to_date_udf 
    (i_tx VARCHAR2, 
    i_format_tx VARCHAR2:='YYYYMMDD')
RETURN DATE DETERMINISTIC IS
    PRAGMA UDF;
BEGIN
    RETURN to_date(i_tx,i_format_tx);
EXCEPTION
    WHEN OTHERS THEN
        IF sqlcode BETWEEN -1899 AND -1800 THEN
            RETURN NULL;
        ELSE
            RAISE;
        END IF;
END;
/
-- This statement will fail
CREATE INDEX test_tab_idx ON test_tab(f_to_date_udf(last_ddl_tx))
/
-- This statement will also fail
ALTER FUNCTION f_to_date_udf NONEDITIONABLE
/

-- Recreate function with NONEDITIONABLE property
DROP FUNCTION f_to_date_udf
/
CREATE OR REPLACE NONEDITIONABLE FUNCTION f_to_date_udf 
    (i_tx VARCHAR2, 
    i_format_tx VARCHAR2:='YYYYMMDD')
RETURN DATE DETERMINISTIC IS
    PRAGMA UDF;
BEGIN
    RETURN to_date(i_tx,i_format_tx);
EXCEPTION
    WHEN OTHERS THEN
        IF sqlcode BETWEEN -1899 AND -1800 THEN
            RETURN NULL;
        ELSE
            RAISE;
        END IF;
END;
/
-- Now creation of index will succeed
CREATE INDEX test_tab_idx ON test_tab(f_to_date_udf(last_ddl_tx))
/