CREATE EDITION test_e1
/
-- create function in the base edition
ALTER SESSION SET EDITION = ORA$BASE
/
CREATE OR REPLACE FUNCTION f_up_tx (i_tx VARCHAR2) RETURN VARCHAR2 IS
BEGIN 
    RETURN upper(i_tx)||'A'; 
END;
/
-- alter function in the new edition
ALTER SESSION SET EDITION = test_e1
/
CREATE OR REPLACE FUNCTION f_up_tx (i_tx VARCHAR2) RETURN VARCHAR2 IS
BEGIN 
    RETURN upper(i_tx)||'B'; 
END;
/
-- drop function in the new edition
DROP FUNCTION f_up_tx
/
-- try to create non-editionable version - it will fail
CREATE NONEDITIONABLE FUNCTION f_up_tx (i_tx VARCHAR2) RETURN VARCHAR2 IS
BEGIN 
    RETURN upper(i_tx)||'B'; 
END;
/
-- Check regular USER_OBJECTS
SELECT object_name, object_type, edition_name, editionable
FROM user_objects
WHERE object_name = 'F_UP_TX';
-- Check edition-enabled USER_OBJECTS_AE
SELECT object_name, object_type, edition_name, editionable
FROM user_objects_ae
WHERE object_name = 'F_UP_TX'
/
-- Drop function in the original edition
ALTER SESSION SET EDITION=ora$base
/
DROP FUNCTION f_up_tx
/
-- Create non-editionable version of the function
CREATE NONEDITIONABLE FUNCTION f_up_tx (i_tx varchar2) RETURN VARCHAR2 IS
BEGIN 
    RETURN upper(i_tx)||'B'; 
END;
/
-- Validate creation in USER_OBJECTS_AE
SELECT object_name, object_type, edition_name, editionable
FROM user_objects_ae
WHERE object_name = 'F_UP_TX'
/