-- setup testing environment
CREATE OR REPLACE FUNCTION f_getPGA_nr RETURN NUMBER AS
    v_nr NUMBER;
BEGIN
    SELECT b.value
    INTO v_nr
    FROM v$statname a, v$mystat b
    WHERE a.statistic# = b.statistic#
    AND a.name = 'session pga memory';
    RETURN v_nr;
END;
/
CREATE OR REPLACE PROCEDURE p_testVarchar2 (pi_length_nr NUMBER) IS
BEGIN
    EXECUTE IMMEDIATE
    'DECLARE'||chr(10)||
    ' v_before_nr NUMBER;'||CHR(10)||
    ' v_after_nr NUMBER;'||CHR(10)||
    ' v_level_nr NUMBER:=0;'||CHR(10)||
    ' PROCEDURE p_DrillDown(pi_tx VARCHAR2) IS'||CHR(10)||
    ' v_tx VARCHAR2('||pi_length_nr||'):=pi_tx;'||CHR(10)||
    ' BEGIN'||chr(10)||
    ' v_level_nr:=v_level_nr+1;'||CHR(10)||
    ' IF v_level_nr <=1000 THEN'||CHR(10)||
    ' p_DrillDown(pi_tx);'||CHR(10)||
    ' END IF;'||CHR(10)||
    ' END;'||CHR(10)||
    'BEGIN'||CHR(10)||
    ' v_before_nr:=f_getPGA_nr;'||CHR(10)||
    ' p_DrillDown(''A'');'||CHR(10)||
    ' v_after_nr:=f_getPGA_nr;'||CHR(10)||
    ' dbms_output.put_line('''||pi_length_nr||':''||(v_after_nr-v_before_nr));'||CHR(10)||
    'END;';
END;
/
-- run tests
connect scott/TIGER@pdbora12c
set serveroutput on
exec p_TestVarchar2(1);
connect scott/TIGER@pdbora12c
set serveroutput on
exec p_TestVarchar2(100);
connect scott/TIGER@pdbora12c
set serveroutput on
exec p_TestVarchar2(1000);
connect scott/TIGER@pdbora12c
set serveroutput on
exec p_TestVarchar2(2000);
connect scott/TIGER@pdbora12c
set serveroutput on
exec p_TestVarchar2(3000);
connect scott/TIGER@pdbora12c
set serveroutput on
exec p_TestVarchar2(4000);
connect scott/TIGER@pdbora12c
set serveroutput on
exec p_TestVarchar2(4001);
connect scott/TIGER@pdbora12c
set serveroutput on
exec p_TestVarchar2(32767);
