set timing on
-- SYSDATE inside the loop
DECLARE
    v_count1_nr NUMBER:=0;
    v_count2_nr NUMBER:=0;
BEGIN
    FOR c IN (SELECT * FROM test_tab) LOOP
        if c.created > sysdate-180 THEN -- inside the loop
            v_count1_nr:=v_count1_nr+1;
        ELSE
            v_count2_nr:=v_count2_nr+1;
        END IF;
    END LOOP;
END;
/
-- SYSDATE outside of the loop
DECLARE
    v_count1_nr NUMBER:=0;
    v_count2_nr NUMBER:=0;
    v_dt DATE:=sysdate; -- calculated once
BEGIN
    FOR c IN (SELECT * FROM test_tab) LOOP
        IF c.created > v_dt-180 THEN
            v_count1_nr:=v_count1_nr+1;
        ELSE
            v_count2_nr:=v_count2_nr+1;
        END IF;
    END LOOP;
END;
/
-- TIMESTAMP instead of DATE inside the loop
DECLARE
    v_count1_nr NUMBER:=0;
    v_count2_nr NUMBER:=0;
BEGIN
    FOR c IN (SELECT * FROM test_tab) LOOP
        IF c.created > systimestamp-180 THEN
            v_count1_nr:=v_count1_nr+1;
        ELSE
            v_count2_nr:=v_count2_nr+1;
        END IF;
    END LOOP;
END;
/
