CREATE OR REPLACE TYPE parallel_ot IS OBJECT
    (id_nr NUMBER, 
     name_tx VARCHAR2(50), 
     type_cd VARCHAR2(50))
/
CREATE OR REPLACE TYPE parallel_tt IS TABLE OF parallel_ot
/
CREATE OR REPLACE FUNCTION f_collection_tt 
RETURN parallel_tt IS
    v_out_tt parallel_tt:=parallel_tt();
BEGIN
    v_out_tt.extend(1000000);
    FOR i IN 1..1000000 LOOP
        v_out_tt(i):= parallel_ot(i,'Name'||i,'Type'||MOD(i,4));
    END LOOP;
    RETURN v_out_tt;
END;
/
CREATE OR REPLACE FUNCTION f_collectionPipe_tt 
RETURN parallel_tt
PIPELINED
IS
    v_out parallel_ot;
BEGIN
    FOR i IN 1..1000000 LOOP
        v_out:=parallel_ot(i,'Name'||i,'Type'||MOD(i,4));
        PIPE ROW(v_out);
    END LOOP;
END;
/
set timing on

SELECT type_cd, count(*) 
FROM TABLE(f_collection_tt) 
GROUP BY type_cd
/
SELECT type_cd, count(*) 
FROM TABLE(f_collectionPipe_tt) 
GROUP BY type_cd
/